using System;
using System.Collections;

namespace AdhiC
{

	/**
	 * This class forms the core of any business application.  It
	 * encapsulates business rules and contains a value object and 
	 * a data access object. 
	 * @author DKRISHNA
	 *
	 */
	[Serializable]
	public abstract class BusinessObject
	{
        private ValueObject vo;

        private DataAccessObject ado;

		public BusinessObject(DataAccessObject dataAccess, ValueObject valueObject)
		{
			//
			// TODO: Add constructor logic here
			//
			ado = dataAccess;
			vo = valueObject;
			
		}

		/**
		 * returns the data access object
		 * @return the data access object
		 */
		public DataAccessObject ADO
		{
            get
            {
                return ado;
            }
            set
            {
                ado = value;
            }
		}

		/**
		 * returns the value object
		 * @return the vO.
		 */
		public ValueObject VO 
		{
            get
            {
                return vo;
            }
            set
            {
                vo = value;
            }
        }

		/**
		 * sets the mode on the value objects
		 * @param valueObjects the value objects
		 * @param mode the mode to set
		 */
		public void SetMode(ArrayList valueObjects, Mode mode)
		{
			if(valueObjects != null && valueObjects.Count > 0)
			{
				int size = valueObjects.Count;
				ValueObject valueObject = null;
				for(int i=0; i < size; i++)
				{
					valueObject= (ValueObject) valueObjects[i];
					valueObject.Mode = mode;
				}
			}
		}

	}
}