using System;
using System.Collections;

namespace AdhiC
{


	/**
	 * The value objects holds the attributes of a business object.  Value objects are 
	 * always contained within a business object.  Value objects are passed into a data
	 * access object for database operation.  These are passed to the clients of business
	 * objects and services when they need information or state about a business object.
	 * @author DKRISHNA
	 *
	 * 
	 */
	[Serializable]
	public abstract class ValueObject : IComparable
	{
		public Mode mode;
		public long id;
		public String name;
	
		/**
		 * returns the mode
		 * @return the mode
		 */
		public Mode Mode 
		{
            get
            {
			return mode;
            }
            set
            {
                mode = value;
            }
		}

		/**
		 * returns the object id
		 * @return the object id
		 */
		public long ID
		{
            get
            {
                return id;
            }
            set
            {
                id = value;
            }
		}

		/**
		 * returns the object name
		 * @return the object name
		 */
		public String Name
		{
            get
            {
                return name;
            }
            set
            {
                name = value;
            }
		}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public override bool Equals(Object arg0) 
{
	ValueObject vo = (ValueObject)arg0;
	bool ret = false;
	if(vo != null)
{
	ret = (ID == vo.ID);
}
	return ret;
}

	    public override int GetHashCode()
        {
            return System.Convert.ToInt32(this.ID);
        }
	/**
	 * returns the cloned value object
	 * @param vo the cloned value object
	 * @return the cloned value object
	 */
	virtual public Object  Clone(ValueObject vo)
{
	vo.ID = this.ID;
	vo.Mode = this.Mode;
	vo.Name = this.Name;
	return vo ;
}
	
	/**
	 * the compareto method for object comparison
	 */
	virtual public int CompareTo(Object obj)
{
	int ret = 1;
	ValueObject vo = (ValueObject)obj;	
	if(vo != null)
{
	if(id > vo.ID) ret = 1;
	else if(id < vo.ID) ret = -1;
	else ret = 0;
}
	return ret;
}

}
}