using System;
using System.Data.SqlClient;
using System.Data;

namespace AdhiC.db
{
	/// <summary>
	/// Summary description for AdhiSQLCommand.
	/// </summary>
	public class AdhiSQLCommand : AdhiDBCommand
	{
		//the constructor which takes in a connection object and the
		//command string
		public AdhiSQLCommand(string commandStr,SqlConnection connection)
		{
			command = new SqlCommand(commandStr, connection);
		}

		//executes a non query
		public override int ExecuteNonQuery()
		{
			int ret=0;
			if(this.command !=null) 
			{
				ret = ((SqlCommand)this.command).ExecuteNonQuery();
			}
			return ret;
		}
		//executes a scalar function
		public override int ExecuteScalar()
		{
			int ret=0;
			if(this.command != null )
			{
				ret = System.Convert.ToInt32(((SqlCommand)this.command).ExecuteScalar());
			}
			return ret;
		}

		//sets the command text
		public override void SetCommandText(string cmdStr)
		{
			if(this.command  != null )
			{	
				((SqlCommand)this.command).CommandText = cmdStr;
			}
		}

		//sets the command Type
		public override void SetCommandType(CommandType cmdType)
		{
			if(this.command  != null )
			{	
				((SqlCommand)this.command).CommandType = cmdType;
			}
		}

		//sets the command parameter
		public override void SetParameters( string[] variables,object[] values)
		{
			if(this.command  != null )
			{	
				if(!variables[0].ToString().Equals (string.Empty))
				{
					// Loop through all the parameters and values
					for(int i=0; i<variables.Length; i++)
					{
						SqlParameter cmdParameter = new SqlParameter(variables[i].ToString(),values[i]);
						((SqlCommand)this.command).Parameters.Add(cmdParameter);
					}	
					
				}
			}
		}

		//executes a query and returns a rowset object
		public override DataSet Find()
		{

			DataSet table = new DataSet();
			
			try
			{
				if(this.command != null ) 
				{
					SqlDataAdapter adapter = new SqlDataAdapter(((SqlCommand)this.command));
					adapter.Fill(table);
				}
			}
			catch(Exception e)
			{
				throw e;
			}
			return table;
		}

	}
}
